// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/VehicleRole.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_role__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__VehicleRole__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x4f, 0xe0, 0x29, 0xe0, 0x2b, 0x91, 0x8d, 0x05,
      0xeb, 0xe1, 0x35, 0x0a, 0xc1, 0xc0, 0xa3, 0x2a,
      0xe2, 0x24, 0x9f, 0x0a, 0x6c, 0x26, 0x60, 0x20,
      0x90, 0x4a, 0x63, 0x45, 0x45, 0x06, 0x76, 0x68,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__VehicleRole__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/VehicleRole";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__VehicleRole__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__VehicleRole__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__VehicleRole__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__VehicleRole__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__VehicleRole__TYPE_NAME, 36, 36},
      {etsi_its_cam_ts_msgs__msg__VehicleRole__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn\n"
  "#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cam_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates the role played by a vehicle at a point in time.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `default`          - to indicate the default vehicle role as indicated by the vehicle type,\n"
  "#  * - 1 `publicTransport`  - to indicate that the vehicle is used to operate public transport service,\n"
  "#  * - 2 `specialTransport` - to indicate that the vehicle is used for special transport purpose, e.g. oversized trucks,\n"
  "#  * - 3 `dangerousGoods`   - to indicate that the vehicle is used for dangerous goods transportation,\n"
  "#  * - 4 `roadWork`         - to indicate that the vehicle is used to realize roadwork or road maintenance mission,\n"
  "#  * - 5 `rescue`           - to indicate that the vehicle is used for rescue purpose in case of an accident, e.g. as a towing service,\n"
  "#  * - 6 `emergency`        - to indicate that the vehicle is used for emergency mission, e.g. ambulance, fire brigade,\n"
  "#  * - 7 `safetyCar`        - to indicate that the vehicle is used for public safety, e.g. patrol,\n"
  "#  * - 8 `agriculture`      - to indicate that the vehicle is used for agriculture, e.g. farm tractor, \n"
  "#  * - 9 `commercial`       - to indicate that the vehicle is used for transportation of commercial goods,\n"
  "#  * - 10 `military`        - to indicate that the vehicle is used for military purpose, \n"
  "#  * - 11 `roadOperator`    - to indicate that the vehicle is used in road operator missions,\n"
  "#  * - 12 `taxi`            - to indicate that the vehicle is used to provide an authorized taxi service,\n"
  "#  * - 13 `uvar`            - to indicate that the vehicle is authorized to enter a zone according to the applicable Urban Vehicle Access Restrictions.\n"
  "#  * - 14 `rfu1`            - is reserved for future usage.\n"
  "#  * - 15 `rfu2`            - is reserved for future usage.\n"
  "#  * \n"
  "#  * @category: Vehicle Information\n"
  "#  * @revision: Description updated in V2.1.1 (removed reference to CEN/TS 16157-3), value 13 assigned in V2.2.1\n"
  "#  */\n"
  "# VehicleRole ::= ENUMERATED {\n"
  "#     default         (0), \n"
  "#     publicTransport (1), \n"
  "#     specialTransport(2), \n"
  "#     dangerousGoods  (3), \n"
  "#     roadWork        (4), \n"
  "#     rescue          (5), \n"
  "#     emergency       (6), \n"
  "#     safetyCar       (7), \n"
  "#     agriculture     (8), \n"
  "#     commercial      (9), \n"
  "#     military        (10), \n"
  "#     roadOperator    (11), \n"
  "#     taxi            (12), \n"
  "#     uvar            (13), \n"
  "#     rfu1            (14), \n"
  "#     rfu2            (15)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 DEFAULT = 0\n"
  "uint8 PUBLIC_TRANSPORT = 1\n"
  "uint8 SPECIAL_TRANSPORT = 2\n"
  "uint8 DANGEROUS_GOODS = 3\n"
  "uint8 ROAD_WORK = 4\n"
  "uint8 RESCUE = 5\n"
  "uint8 EMERGENCY = 6\n"
  "uint8 SAFETY_CAR = 7\n"
  "uint8 AGRICULTURE = 8\n"
  "uint8 COMMERCIAL = 9\n"
  "uint8 MILITARY = 10\n"
  "uint8 ROAD_OPERATOR = 11\n"
  "uint8 TAXI = 12\n"
  "uint8 UVAR = 13\n"
  "uint8 RFU1 = 14\n"
  "uint8 RFU2 = 15\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__VehicleRole__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__VehicleRole__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4658, 4658},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__VehicleRole__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__VehicleRole__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
